////////////////////////////////////////////////////
// Web Example Four: Remote Data Editing
// Example4.exe
////////////////////////////////////////////////////

Set talk OFF   // turn off interactive mode
Set century ON // Y2K
 
Try  // Error trap entire CGI applet. 

   ////// Create new instance of the Web Class
   Set proc to WebClass.cc additive 
   oCGI = new CGISession ()                            

   ////// Connect to the Web Server (StdIn/StdOut)
   oCGI.Connect()
  
   ////// Open Query 
   cTable = "USERS.DBF"
   q = new query()
   q.sql = [Select * from "] + cTable + ["]
   q.active = true
   q.rowset.indexName = "userID"

   if oCGI.isKey('userid')
      cUserID = oCGI['userid']
   endif

//  there are two essential procedures in this application
//  First we must look up the record that is to be edited.  The user passes
//  some information necessary to find the record.

do case
case oCGI.isKey("finduser")
   /// locate the record to be modified
   if q.rowset.findKey( cUserID )
      
      if oCGI["password"] == q.rowset.fields["password"].value
      
         PrintUserInfo()
      
      else
         
         cMsg = "<h2>The password you entered is not valid. Please reenter.</h2>"
         oCGI.StreamHeader()
         oCGI.StreamBody( cMsg  )
         oCGI.StreamFooter()

      endif
   else
      cMsg = "<h2>" + cUserID + " is not on file. Please open a new account.</h2>"
      oCGI.StreamHeader()
      oCGI.StreamBody( cMsg  )
      oCGI.StreamFooter()

   endif

case oCGI.isKey("modifyuser")
         
   /// Update the user information in the table
   q.rowset.indexname := "tableid"
   nPlace = val(oCGI["place"])
   q.rowset.findKey( nPlace )

   oCGI.loadFieldsFromArray(q.rowset.fields, false)
   
   ///  Print a response page
   cMsg = "<h2>Your information has been modified.</h2>"
   oCGI.StreamHeader()
   oCGI.StreamBody( cMsg  )
   oCGI.StreamFooter()
   
otherwise
   cMsg = "<h2>Click here to start this application.</h2>"
   oCGI.StreamHeader()
   oCGI.StreamBody( cMsg  )
   oCGI.StreamFooter()

endcase

catch (exception e)
 
    oCGI.errorPage(e)
 
endtry 

///cleanup our mess
oCGI = null 

////// all done
Quit
////// End ////// 





////////////////////////////////////////////////////
// Appendix One
// PrintUserInfo()
////////////////////////////////////////////////////

function PrintUserInfo
   
   // Create a local instance of the rowset field array.
   local f
   f = q.rowset.fields
   with ( oCGI.fOut )   
      puts('Content-type: text/html')
      puts('')   
      puts([<HTML><HEAD>])
      puts([<TITLE>Make User</TITLE>])
      puts([</HEAD>])
      puts([<BODY TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000EE" VLINK="#551A8B" ALINK="#FF0000">])
      puts([<TABLE WIDTH="100%"> ])
      puts([<TR>])
      puts([<TD colspan=2></TD>])
      puts([</TR>])
      puts([<TR VALIGN=TOP>])
      puts([<TD VALIGN=TOP WIDTH="20%"> ])
      puts([</TD>])
      puts([<TD WIDTH="80%">])
      puts([<BR><B>Account Information</B>])
      puts([<BR>])

      puts([<FORM METHOD="POST" ACTION="example4.exe" ENCTYPE="application/x-www-form-urlencoded">])
   
      ///  Add a hidden field with a table's key value. 
      ///  This is used to find the record when the data 
      ///  is resubmited to the server.
      cRecno = str(q.rowset.fields["tableid"].value,3,0)
      puts([<INPUT TYPE="HIDDEN" NAME="place" VALUE="] + cRecno + [">])
   
      puts([<FONT FACE="Arial,Helvetica" SIZE=-1>Enter])
      puts([your first name, last name, and user ID number in the following field])
      puts([boxes.</FONT>])
      puts([<UL><TABLE>])
      puts([<TR>])
      puts([<TD Width="40%"><FONT FACE="Arial,Helvetica" SIZE=-1>First Name:</FONT></TD>])
   
      if not empty(f["fname"].value)
         cValue = [ VALUE="] + trim(f["fname"].value) + ["]
      else
	     cValue = ""
	  endif
	  puts([<TD><FONT FACE="Arial,Helvetica" SIZE=-1><INPUT TYPE="TEXT" NAME="fname" MAXLENGTH="40"] ;
                  + cValue + [></FONT></TD>])
   
      puts([</TR>])
      puts([<TR>])
      puts([<TD Width="40%"><FONT FACE="Arial,Helvetica" SIZE=-1>Last Name:</FONT></TD>])
      
	  if not empty(f["lname"].value)
         cValue = [ VALUE="] + trim(f["lname"].value) + ["]
      else
	     cValue = ""
	  endif
      puts([<TD><FONT FACE="Arial,Helvetica" SIZE=-1><INPUT TYPE="TEXT" NAME="lname" MAXLENGTH="40"] ;
                    + cValue + [></FONT></TD>])
      puts([</TR>])
      puts([<TR>])
      puts([<TD Width="40%"><FONT FACE="Arial,Helvetica" SIZE=-1>User ID:</FONT></TD>])
	  
	  if not empty(f["userid"].value)
         cValue = [ VALUE="] + trim(f["userid"].value) + ["]
      else
	     cValue = ""
	  endif
      puts([<TD><FONT FACE="Arial,Helvetica" SIZE=-1><INPUT TYPE="TEXT" NAME="userid" MAXLENGTH="11"] ;
                   + cValue + [></FONT></TD>])
   
      puts([</TR>])
      puts([</TABLE></UL>])

      puts([<UL><TABLE>])
      puts([<TR>])
      puts([<TD Width="40%"><FONT FACE="Arial,Helvetica" SIZE=-1>eMail address:</FONT></TD>])

	  if not empty(f["email"].value)
         cValue = [ VALUE="] + trim(f["email"].value) + ["]
      else
	     cValue = ""
	  endif
      puts([<TD><FONT FACE="Arial,Helvetica" SIZE=-1><INPUT TYPE="TEXT" NAME="Email" MAXLENGTH="40"] ;
                  + cValue + [></FONT></TD>])
      puts([</TR>])
      puts([<TR>])
      puts([<TD Width="40%"><FONT FACE="Arial,Helvetica" SIZE=-1>Password:</FONT></TD>])

	  if not empty(f["password"].value)
         cValue = [ VALUE="] + trim(f["password"].value) + ["]
      else
	     cValue = ""
	  endif
      puts([<TD><FONT FACE="Arial,Helvetica" SIZE=-1><INPUT TYPE="PASSWORD" NAME="password" MAXLENGTH="15"] ;
                   + cValue + [></FONT></TD>])
      puts([</TR>])
      puts([<TR>])
      puts([<TD Width="40%"><FONT FACE="Arial,Helvetica" SIZE=-1>Password (again):</FONT></TD>])

      
      puts([<TD><FONT FACE="Arial,Helvetica" SIZE=-1><INPUT TYPE="PASSWORD" NAME="password2" MAXLENGTH="15"] ;
                  + cValue + [></FONT></TD>])
      puts([</TR>])
      puts([</TABLE></UL>])
      
      /// This is the submit button.  It's NAME is evaluated
      /// by the application to control the flow of executution.
      puts([<INPUT TYPE="SUBMIT" NAME="modifyuser" VALUE="Submit Information">])
      puts([<INPUT TYPE="RESET" NAME="Reset" VALUE="Reset Form">])
      puts([</FORM></TD>])
      puts([</TR>])
      puts([</TABLE>])
      puts([</BODY>])
      puts([</HTML>])
   endwith

quit
return
