///////////////////////////////////////////////////////////
// Web Example Five: Using ParseHTML.cc
// Example5.exe
// 
//  
///////////////////////////////////////////////////////////

Set talk OFF   // turn off interactive mode
Set century ON // Y2K
 
Try  // Error trap entire CGI applet. 

   ////// Create new instance of the Web Class
   /////  ParseHTML.cc is subclassed from WebClass.cc
   /////////////////////////////////////////////////////
   // Note that this is a subclass of WebClass.cc
   // and therefore, you have access to all the 
   // functions in WebClass.
   /////////////////////////////////////////////////////
   Set proc to ParseHTML.cc additive
   oCGI = new ParseHTML() 
   ////// Connect to the Web Server (StdIn/StdOut)
   oCGI.Connect()
  
   ////// Open Query 
   cTable = "Users.DBF"
   q = new query()
   q.sql = [Select * from "] + cTable + ["]
   q.active = true
   q.rowset.indexName = "userID"

   if oCGI.isKey('userid')
      cUserID = oCGI['userid']
   endif


   /// locate the record to be modified
   if q.rowset.findKey( cUserID )
      
      if oCGI["password"] == q.rowset.fields["password"].value
      
            ////////////////////////////////////////////////////////
            // Set the name of the page template that will be 
            // displayed. This can be set as a fixed page: 
            //   cHTMLFile = "c:\webdocs\loader\edituser.html"
            // Or the page name can be passed in the the HTML form:
            //   cHTMLFile = oCGI['pagename']
            ////////////////////////////////////////////////////////
          
            cHTMLFile = oCGI['pagename']
         
            ////////////////////////////////////////////////////////////
            //  At this point the record pointer of the rowset should
            //  be at the record you want to edit.  You can now call
            //  DisplayHTML()
            ////////////////////////////////////////////////////////////
                   
            oCGI.DisplayHTML(q.rowset.fields,cHTMLFile)
            
      else
         
         cMsg = "<h2>The password you entered is not valid. Please reenter.</h2>"
         oCGI.StreamHeader()
         oCGI.StreamBody( cMsg  )
         oCGI.StreamFooter()

      endif
   else
      cMsg = "<h2>" + cUserID + " is not on file. Please open a new account.</h2>"
      oCGI.StreamHeader()
      oCGI.StreamBody( cMsg  )
      oCGI.StreamFooter()

   endif


catch (exception e)
 
    oCGI.errorPage(e)
 
endtry 

///cleanup our mess
oCGI = null 

////// all done
Quit
////// End ////// 
